﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

using Syncfusion.Pdf.Interactive;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Windows.Forms.PdfViewer;
using System.Windows.Forms;
using System.Drawing;

namespace PDFUtils
{
    class Program
    {
        private const char SEPARATOR = '|';
        private const string NEWLINE = "¤";
        private static string _commande;
        private static string _sourceFile;
        private static string _resultFile;
        private static string _errorFile;
        private static string _fieldList;
        private static string _valueList;
        private static Dictionary<string, string> _dicValue;
        private static string _cheminSignatureClient;
        private static string _cheminSignatureTechnicien;
        private static string _printerToUse;

        private static PdfLoadedDocument _doc;
        private static PdfLoadedForm _form;

        static void Main(string[] args)
        {
            Console.Title = "PDF UTILS (v 0.5.0)";

            var param = Environment.GetCommandLineArgs();

#if DEBUG

            ////************** TEST FILL *********************
            //var command = "FILL";
            //var sourceFile = Path.Combine("cerfa_empty.pdf");
            //var resultFile = Path.Combine("cerfa_result.pdf");
            //var fieldList = "topmostSubform[0].Page1[0].Champ_de_texte1[0]|topmostSubform[0].Page1[0].Champ_de_texte1[1]|topmostSubform[0].Page1[0].Champ_de_texte1[2]|topmostSubform[0].Page1[0].Champ_de_texte1[3]|topmostSubform[0].Page1[0].Champ_de_texte1[4]|topmostSubform[0].Page1[0].Champ_de_texte1[5]|topmostSubform[0].Page1[0].Champ_de_texte1[6]|topmostSubform[0].Page1[0].Champ_de_texte1[7]|topmostSubform[0].Page1[0].Champ_de_texte1[8]|topmostSubform[0].Page1[0].Case_à_cocher1[0]|topmostSubform[0].Page1[0].Case_à_cocher1[1]|topmostSubform[0].Page1[0].Case_à_cocher1[2]|topmostSubform[0].Page1[0].Case_à_cocher1[3]|topmostSubform[0].Page1[0].Case_à_cocher1[4]|topmostSubform[0].Page1[0].Case_à_cocher1[5]|topmostSubform[0].Page1[0].Case_à_cocher1[6]|topmostSubform[0].Page1[0].Case_à_cocher1[7]|topmostSubform[0].Page1[0].Champ_de_texte1[9]|topmostSubform[0].Page1[0].Champ_de_texte1[10]|topmostSubform[0].Page1[0].Champ_de_texte1[11]|topmostSubform[0].Page1[0].Champ_de_texte1[12]|topmostSubform[0].Page1[0].Champ_de_texte1[13]|topmostSubform[0].Page1[0].Groupe_de_boutons_radio[0]|topmostSubform[0].Page1[0].Groupe_de_boutons_radio[1]|topmostSubform[0].Page1[0].Groupe_de_boutons_radio[2]|topmostSubform[0].Page1[0].Groupe_de_boutons_radio[3]|topmostSubform[0].Page1[0].Groupe_de_boutons_radio[4]|topmostSubform[0].Page1[0].Groupe_de_boutons_radio[5]|topmostSubform[0].Page1[0].Champ_de_texte1[14]|topmostSubform[0].Page1[0].Champ_de_texte1[15]|topmostSubform[0].Page1[0].Champ_de_texte1[16]|topmostSubform[0].Page1[0].Groupe_de_boutons_radio[6]|topmostSubform[0].Page1[0].Groupe_de_boutons_radio[7]|topmostSubform[0].Page1[0].Groupe_de_boutons_radio[8]|topmostSubform[0].Page1[0].Champ_de_texte1[17]|topmostSubform[0].Page1[0].Champ_de_texte1[18]|topmostSubform[0].Page1[0].Champ_de_texte1[19]|topmostSubform[0].Page1[0].Champ_de_texte1[20]|topmostSubform[0].Page1[0].Champ_de_texte1[21]|topmostSubform[0].Page1[0].Champ_de_texte1[22]|topmostSubform[0].Page1[0].Champ_de_texte1[23]|topmostSubform[0].Page1[0].Champ_de_texte1[24]|topmostSubform[0].Page1[0].Groupe_de_boutons_radio[9]|topmostSubform[0].Page1[0].Champ_de_texte1[25]|topmostSubform[0].Page1[0].Champ_de_texte1[26]|topmostSubform[0].Page1[0].Champ_de_texte1[27]|topmostSubform[0].Page1[0].Champ_de_texte1[28]|topmostSubform[0].Page1[0].Champ_de_texte1[29]|topmostSubform[0].Page1[0].Champ_de_texte1[30]|topmostSubform[0].Page1[0].Champ_de_texte1[31]|topmostSubform[0].Page1[0].Champ_de_texte1[32]|topmostSubform[0].Page1[0].Champ_de_texte1[33]|topmostSubform[0].Page1[0].Champ_de_texte1[34]|topmostSubform[0].Page1[0].Champ_de_texte1[35]|topmostSubform[0].Page1[0].Champ_de_texte1[36]|topmostSubform[0].Page1[0].Champ_de_texte1[37]|topmostSubform[0].Page1[0].Champ_de_texte1[38]|topmostSubform[0].Page1[0].Champ_de_texte1[39]|topmostSubform[0].Page1[0].Champ_de_texte1[40]|topmostSubform[0].Page1[0].Champ_de_texte1[41]|topmostSubform[0].Page1[0].Champ_de_texte1[42]|topmostSubform[0].Page1[0].Champ_image1[0]|topmostSubform[0].Page1[0].Champ_de_texte2[0]";
            //var valueList = "R1705001901|¤¤¤ |ATTEST|CRODAROM S.A.S.¤Z.A. LES PLAINES¤¤¤48230¤CHANAC|DAIKIN Unités Intérieures x 10 tyu|R410A|250|0.5||0|0|0|0|0|0|0|0||||||1|1|-1|1|-1|1||||-1|-1|-1|||||||||1|°cccc|||||||||04BOUDIGNON JEREMY|||TECHNICIEN|24/05/17||||||";
            //var cheminSignCli = "";
            //var cheminSignTech = "";
            //var printerName = "";
            //param = new string[] { "<chemin_exe>", command, sourceFile, resultFile, fieldList, valueList, cheminSignCli, cheminSignTech, "Copieur NB Olivetti" };
            ////*********************************************

            ////************** TEST PRINT *********************
            var command = "PRINT";
            var sourceFile = Path.Combine("cerfa_empty.pdf");
            var sourceFile_2 = Path.Combine("cerfa_result.pdf");
            var resultFile = "";
            var fieldList = "";
            var valueList = "";
            var cheminSignCli = "";
            var cheminSignTech = "";
            var printerName = "***** PUT HERE YOUR PRINTER'S NAME *****";
            param = new string[] { "<chemin_exe>", command, sourceFile, resultFile, fieldList, valueList, cheminSignCli, cheminSignTech, printerName };
            ////*********************************************
#endif

            var parametresCorrectes = false;
            _errorFile = Path.Combine(Application.StartupPath, "pdfutilserreurs.txt");

            try
            {
                LireParametresRecus(param);
                parametresCorrectes = true;
            }
            catch (Exception ex)
            {
                parametresCorrectes = false;
                AfficherMessageErreur(string.Format("ERREUR DE PARAMETRES : {0}", ex.Message));
            }

            if (parametresCorrectes)
            {
                AfficherParametres();
                try
                {
                    if (string.IsNullOrEmpty(_commande))
                        throw new Exception("Aucune commande indiquée");
                    switch (_commande)
                    {
                        case "LSFIELD":
                            InitialiserObjets();
                            TesterFichierSource();
                            ListerChampsDuPDF();
                        break;
                        case "FILL":
                            InitialiserObjets();
                            TesterFichierSource();
                            TesterFichierDestination();
                            FusionnerDocumentPDF();
                            break;
                        case "LSPRINT":
                            TesterFichierDestination();
                            ListeLesImprimantes();
                            break;
                        case "PRINT":
                            TesterFichierSource();
                            Imprimer();
                            break;
                        case "PRINT2":
                            InitialiserObjets();
                            TesterFichierSource();
                            Imprimer2();
                            break;
                        default:
                            throw new Exception(string.Format("Commande \"{0}\" non valide", _commande));
                            break;
                    }
                }
                catch (Exception ex)
                {
                    File.AppendAllText(_errorFile, string.Format("[{0}] {1}{2}", DateTime.Now.ToString(), ex.Message, Environment.NewLine));
                    // Ne pas afficher le message dans la console car lorsqu'elle est appelée depuis SAV+, elle n'est pas affichée et donc 
                    // l'utilisateur ne peut pas appuyer sur une touche pour fermer la console.
                    //AfficherMessageErreur(string.Format("ERREUR D'EXECUTION : {0}", ex.Message));
                }
                finally
                {
                    CloturerObjets();
                }
            }
        }

        private static void TesterFichierSource()
        {
            if (string.IsNullOrEmpty(_sourceFile))
                throw new Exception("Aucun fichier source indiqué");
            if (Path.GetExtension(_sourceFile) != ".pdf")
                throw new Exception("Extension du fichier source incorrecte");
            if (!File.Exists(_sourceFile))
                throw new Exception("Le fichier source n'existe pas");
        }

        private static void TesterFichierDestination()
        {
            if (string.IsNullOrEmpty(_resultFile))
                throw new Exception("Aucun fichier de destination indiqué");
            if (File.Exists(_resultFile))
                File.Delete(_resultFile);
        }

        private static void LireParametresRecus(string[] pParametres)
        {
            if (pParametres.Length != 9)
                throw new Exception("Nombre de paramètres non valide");

            _commande = pParametres[1];
            _sourceFile = pParametres[2];
            _resultFile = pParametres[3];
            _fieldList = pParametres[4];
            _valueList = pParametres[5];
            _cheminSignatureClient = pParametres[6];
            _cheminSignatureTechnicien = pParametres[7];
            _printerToUse = pParametres[8];
        }

        private static void AfficherParametres()
        {
            Console.WriteLine("");
            Console.WriteLine("* PARAMETRES:");
            Console.WriteLine(string.Format("Commande : {0}", _commande));
            Console.WriteLine(string.Format("Fichier Source : {0}", _sourceFile));
            Console.WriteLine(string.Format("Fichier Destination : {0}", _resultFile));
            Console.WriteLine("");
        }

        private static void AfficherMessageErreur(string pMessageErreur)
        {
            Console.WriteLine(pMessageErreur);
            Console.WriteLine("Appuyez sur une touche pour quitter...");
            Console.ReadKey();
        }

        private static void EnregistrerRetourDansFichier(string pMessage)
        {
            Console.WriteLine(pMessage);
            File.AppendAllText(_resultFile, string.Format("{0}\n", pMessage));
        }

        private static void InitialiserObjets()
        {
            _doc = new PdfLoadedDocument(_sourceFile);
            _form = _doc.Form;
            _dicValue = new Dictionary<string, string>();
        }

        private static void CloturerObjets()
        {
            if (_doc != null)
            {
                _doc.Close(true);
                _doc.Dispose();
                _doc = null;
            }
            _form = null;
            _dicValue = null;
        }

        private static void FusionnerDocumentPDF()
        {
            var tabChamp = _fieldList.Split(SEPARATOR);
            var tabValeur = _valueList.Replace(NEWLINE, Environment.NewLine).Split(SEPARATOR);
            if (tabChamp.Length != tabValeur.Length)
                throw new Exception("Le nombre de valeurs de correspond pas au nombre de champs de fusion");
            for (int i = 0; i < tabChamp.Length; i++)
            {
                _dicValue.Add(tabChamp[i], tabValeur[i]);
            }

            PdfFont customFont = new PdfStandardFont(PdfFontFamily.Helvetica, 8);// Car toutes les données ne rentrent pas dans les cadres du CERFA Fluide

            foreach (PdfField field in _form.Fields)
            {
                var fieldName = field.Name;
                try
                {
                    if (field is PdfLoadedTextBoxField) {
                        ((PdfLoadedTextBoxField)field).Font = customFont;
                        ((PdfLoadedTextBoxField)field).Text = _dicValue[fieldName];
                    }
                    
                    else if (field is PdfLoadedCheckBoxField)
                        ((PdfLoadedCheckBoxField)field).Checked = ConvertValueToBool(_dicValue[fieldName]);
                    else if (field is PdfLoadedRadioButtonListField)
                        ((PdfLoadedRadioButtonListField)field).SelectedIndex = ConvertValueToInt(_dicValue[fieldName]);
                }
                catch (Exception ex)
                {
                    throw new Exception(string.Format("{0} (Champ : {1}) : {2}", _commande, fieldName, ex.Message));
                }
            }

            try
            {
                if (!string.IsNullOrEmpty(_cheminSignatureClient))
                    InsererSignature(_cheminSignatureClient, 275, 775);
                if (!string.IsNullOrEmpty(_cheminSignatureTechnicien))
                    InsererSignature(_cheminSignatureTechnicien, 125, 775);
            }
            catch (Exception ex)
            {
                throw new Exception(string.Format("{0} {1} : {2}", _commande, "(Signatures)", ex.Message));
            }

            try
            {
                
                _form.ReadOnly = true; // Document non modifiable mais valeurs sélectionnables
                _form.SetDefaultAppearance(false);
                _doc.Save(_resultFile);
                
            }
            catch (Exception ex)
            {
                throw new Exception(string.Format("{0} {1} : {2}", _commande, "(Enregistrement fichier final)", ex.Message));
            }

        }

        private static bool ConvertValueToBool(string pValue)
        {
            return (pValue == "1");
        }

        private static int ConvertValueToInt(string pValue)
        {
            return Convert.ToInt32(pValue);
        }

        private static void InsererSignature(string pCheminSignature, float pX, float pY)
        {
            Bitmap bitmap = new Bitmap(pCheminSignature);
            bitmap.MakeTransparent(Color.White);
            // On passe par un memoryStream car sinon le fond transparant devient noir sur le PDF
            // src : https://www.syncfusion.com/forums/127624/pdfimage-transparency-lost-when-inserted-in-pdf
            MemoryStream bitmapStream = new MemoryStream();
            bitmap.Save(bitmapStream, System.Drawing.Imaging.ImageFormat.Png);

            PdfBitmap pdfBitmap = new PdfBitmap(bitmapStream);

            var coeff = 4;
            var taille = new Size(480 / coeff, 200 / coeff);

            _doc.Pages[0].Graphics.DrawImage(pdfBitmap, new System.Drawing.PointF(pX, pY), taille);

            pdfBitmap.Dispose();
            bitmapStream.Close();
            bitmapStream.Dispose();
        }

        private static void ListerChampsDuPDF()
        {
            try
            {
                StringBuilder sb = new StringBuilder();
                foreach (PdfField field in _form.Fields)
                {
                    sb.Append(field.Name + Environment.NewLine);
                }
                EnregistrerRetourDansFichier(sb.ToString());
            }
            catch (Exception ex)
            {
                throw new Exception(string.Format("{0} : {1}", _commande, ex.Message));
            }
            finally
            {
            }
        }

        private static void ListeLesImprimantes()
        {
            try
            {
                StringBuilder sb = new StringBuilder();
                foreach (string printer in System.Drawing.Printing.PrinterSettings.InstalledPrinters)
                {
                    sb.Append(printer + Environment.NewLine);
                }
                EnregistrerRetourDansFichier(sb.ToString());
            }
            catch (Exception ex)
            {
                throw new Exception(string.Format("{0} : {1}", _commande, ex.Message));
            }
            finally
            {
            }
        }

        private static void Imprimer()
        {
            PdfViewerControl viewer = new PdfViewerControl();
            PrintDialog dialog = new PrintDialog();
            try
            {
                if (string.IsNullOrEmpty(_printerToUse))
                    throw new Exception("Aucune imprimante indiquée");

                viewer.Load(_sourceFile);

                dialog.AllowPrintToFile = true;
                dialog.AllowSomePages = true;
                dialog.AllowCurrentPage = true;

                dialog.Document = viewer.PrintDocument;
                dialog.Document.PrinterSettings.PrinterName = _printerToUse;
                dialog.Document.Print();
            }
            catch (Exception ex)
            {
                throw new Exception(string.Format("{0} : {1}", _commande, ex.Message));
            }
            finally
            {
                dialog.Dispose();
                viewer.Dispose();
            }
        }

        private static void Imprimer2()
        {
            PdfViewerControl viewer = new PdfViewerControl();
            PrintDialog dialog = new PrintDialog();
            try
            {
                if (string.IsNullOrEmpty(_printerToUse))
                    throw new Exception("Aucune imprimante indiquée");

                _form.Flatten = true;
                _doc.Save();

                viewer.Load(_doc);

                //dialog.AllowPrintToFile = true;
                //dialog.AllowSomePages = true;
                //dialog.AllowCurrentPage = true;

                dialog.Document = viewer.PrintDocument;
                dialog.Document.PrinterSettings.PrinterName = _printerToUse;
                dialog.Document.Print();
            }
            catch (Exception ex)
            {
                throw new Exception(string.Format("{0} : {1}", _commande, ex.Message));
            }
            finally
            {
                dialog.Dispose();
                viewer.Dispose();
            }
        }
    }
}
